
----------------
-- StoneHenge --
----------------
local StoneHenge = Henge:NewModule("StoneHenge")
StoneHenge.fullname = "StoneHenge"
StoneHenge.icon     = "icon"
local ML, SL, PT = nil, nil, nil

function StoneHenge:Test()
	local _, pClass = UnitClass("player")
	return pClass == "WARLOCK"
end

function StoneHenge:Load()
	ML = HengeLocale:LoadStoneHenge()
	SL = AceLibrary("Babble-Spell-2.2")
	PT = AceLibrary("PeriodicTable-2.0")
	self:SetupDB({
		["profile"] = {},
		["char"] = {}
	})
	HengeSphere:AddData({
		["id"]   = "mana",
		["name"] = ML["Mana"],
		["func"] = function()
			return UnitMana("player"), UnitManaMax("player")
		end,
		["event"] = "UNIT_MANA",
		["arg1"] = "player"
	})
	HengeSphere:AddData({
		["id"]   = "soulshards",
		["name"] = ML["Soul Shards"],
		["func"] = function()
			return GetItemCount(6265), 16
		end,
		["event"] = "BAG_UPDATE",
	})
	local spell = {
		-- Summons
		["sumimp"]   =     SL["Summon Imp"],
		["sumvoid"]  =     SL["Summon Voidwalker"],
		["sumsucc"]  =     SL["Summon Succubus"],
		["sumfelh"]  =     SL["Summon Felhunter"],
		["sumfelg"]  =     SL["Summon Felguard"],
		-- Stones
		["hestone"]  =     SL["Create Healthstone"],
		["fistone"]  =     SL["Create Firestone"],
		["spstone"]  =     SL["Create Spellstone"],
		["sostone"]  =     SL["Create Soulstone"],
		-- Armor Spells
		["demarm"]   =     SL["Demon Armor"],
		["felarm"]   =     SL["Fel Armor"],
		-- Curses
		["coa"]      =     SL["Curse of Agony"],
		["cor"]      =     SL["Curse of Recklessness"],
		["cot"]      =     SL["Curse of Tongues"],
		["coe"]      =     SL["Curse of the Elements"],
		["cos"]      =     SL["Curse of Shadow"],
		["cod"]      =     SL["Curse of Doom"],
		["cow"]      =     SL["Curse of Weakness"],
		-- Drains
		["drlife"]   =     SL["Drain Life"],
		["drmana"]   =     SL["Drain Mana"],
		["lifetap"]  =     SL["Life Tap"],
		-- Rituals
		["rosumm"]   =     SL["Ritual of Summoning"],
		["rosoul"]   =     SL["Ritual of Souls"],
		--  Buffs
		["detinvis"] =     SL["Detect Lesser Invisibility"],
		["uwbreath"] =     SL["Underwater Breathing"],
	}
	for k, v in pairs(spell) do
		HengeAction:Add({
			["id"] = k,
			["name"] = v,
			["type"] = "spell",
			["spell"] = v
		})
	end            
	HengeButton:Add({
		["id"]   = "pets",
		["type"] = "menu",
		["name"] = ML["Demons"],
		["desc"] = ML["Summon a pet."],
		["icon"] = "action",
		["children"] = {
			[1] = {
				["type"] = "child",
				["id"] = "sumimp",
				["name"] = spell["sumimp"],
				["icon"] = "action",
				["action"] = "sumimp",
				["options"] = {}
			},
			[2] = {
				["type"] = "child",
				["id"] = "sumvoid",
				["name"] = spell["sumvoid"],
				["icon"] = "action",
				["action"] = "sumvoid",
				["options"] = {}
			},
			[3] = {
				["type"] = "child",
				["id"] = "sumsucc",
				["name"] = spell["sumsucc"],
				["icon"] = "action",
				["action"] = "sumsucc",
				["options"] = {}
			},
			[4] = {
				["type"] = "child",
				["id"] = "sumfelh",
				["name"] = spell["sumfelh"],
				["icon"] = "action",
				["action"] = "sumfelh",
				["options"] = {}
			},
			[1] = {
				["type"] = "child",
				["id"] = "sumfelg",
				["name"] = spell["sumfelg"],
				["icon"] = "action",
				["action"] = "sumfelg",
				["options"] = {}
			},
		},
		["options"] = {
			["action"] = "sumimp",
			["anchor"] = "sphere:Main",
			["xpos"] = 0,
			["ypos"] = 0,
			["angle"] = 30
		}
	})         
	HengeButton:Add({
		["id"]   = "armorbuffs",
		["type"] = "action",
		["name"] = ML["Armor Buffs"],
		["icon"] = "action:LeftButton",
		["actions"] = {
			["LeftButton"] = "demarm",
			["RightButton"] = "felarm"
		},
		["options"] = {
		["anchor"] = "sphere:Main",
			["xpos"] = 0,
			["ypos"] = 0,
			["angle"] = 60
		}
	})
	HengeButton:Add({
		["id"]   = "Rituals",
		["type"] = "action",
		["name"] = ML["Rituals"],
		["icon"] = "action:LeftButton",
		["actions"] = {
			["LeftButton"] = "rosumm",
			["RightButton"] = "rosoul"
		},
		["options"] = {
			["anchor"] = "sphere:Main",
			["xpos"] = 0,
			["ypos"] = 0,
			["angle"] = 91
		}
	})
	HengeButton:Add({
		["id"]   = "Drains",
		["type"] = "action",
		["name"] = ML["Drains"],
		["icon"] = "action:LeftButton",
		["actions"] = {
			["LeftButton"] = "drlife",
			["RightButton"] = "drmana"
		},
		["options"] = {
			["anchor"] = "sphere:Main",
			["xpos"] = 0,
			["ypos"] = 0,
			["angle"] = -34
		}
	})
end
